package com.logicbig.example;

import org.springframework.core.MethodParameter;
import org.springframework.stereotype.Controller;
import org.springframework.validation.BindException;
import org.springframework.web.bind.MissingPathVariableException;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.naming.OperationNotSupportedException;

@Controller
public class ExampleController {

    /**
     * This will throw MissingPathVariableException with response code 500
     */
    @RequestMapping("/test/{id}")
    @ResponseBody
    public String handleRequest (@PathVariable("testId") String id) {
       return "id: "+id;
    }

    /**
     * The exception should be processed by @ExceptionHandler method
     */
    @RequestMapping("/test")
    public String handleRequest2 () throws Exception {
        throw new OperationNotSupportedException();
    }


    @ExceptionHandler
    @ResponseBody
    public String handleException (OperationNotSupportedException b) {
        return "from @ExceptionHandler method: " + b ;
    }
}